# module Comparable

The `Comparable` mixin is used by classes whose objects may be ordered. The class must define the `<=>` operator, which compares the receiver against another object, returning -1, 0, or +1 depending on whether the receiver is less than, equal to, or greater than the other object. If the other object is not comparable then the `<=>` operator should return nil. `Comparable` uses `<=>` to implement the conventional comparison operators (`<`, `<=`, `==`, `>=`, and `>`) and the method `between?`.

    class SizeMatters
      include Comparable
      attr :str
      def <=>(other)
        str.size <=> other.str.size
      end
      def initialize(str)
        @str = str
      end
      def inspect
        @str
      end
    end

    s1 = SizeMatters.new("Z")
    s2 = SizeMatters.new("YY")
    s3 = SizeMatters.new("XXX")
    s4 = SizeMatters.new("WWWW")
    s5 = SizeMatters.new("VVVVV")

    s1 < s2                       #=> true
    s4.between?(s1, s3)           #=> false
    s4.between?(s3, s5)           #=> true
    [ s3, s2, s5, s4, s1 ].sort   #=> [Z, YY, XXX, WWWW, VVVVV]

### Public Instance Methods

obj < other → true or false click to toggle source

Compares two objects based on the receiver's `<=>` method, returning true if it returns -1.

    static VALUE
    cmp_lt(VALUE x, VALUE y)
    {
        if (cmpint(x, y) < 0) return Qtrue;
        return Qfalse;
    }

obj <= other → true or false click to toggle source

Compares two objects based on the receiver's `<=>` method, returning true if it returns -1 or 0.

    static VALUE
    cmp_le(VALUE x, VALUE y)
    {
        if (cmpint(x, y) <= 0) return Qtrue;
        return Qfalse;
    }

obj == other → true or false click to toggle source

Compares two objects based on the receiver's `<=>` method, returning true if it returns 0. Also returns true if obj and other are the same object.

    static VALUE
    cmp_equal(VALUE x, VALUE y)
    {
        VALUE c;
        if (x == y) return Qtrue;

        c = rb_exec_recursive_paired_outer(cmp_eq_recursive, x, y, y);

        if (NIL_P(c)) return Qfalse;
        if (rb_cmpint(c, x, y) == 0) return Qtrue;
        return Qfalse;
    }

obj > other → true or false click to toggle source

Compares two objects based on the receiver's `<=>` method, returning true if it returns 1.

    static VALUE
    cmp_gt(VALUE x, VALUE y)
    {
        if (cmpint(x, y) > 0) return Qtrue;
        return Qfalse;
    }

obj >= other → true or false click to toggle source

Compares two objects based on the receiver's `<=>` method, returning true if it returns 0 or 1.

    static VALUE
    cmp_ge(VALUE x, VALUE y)
    {
        if (cmpint(x, y) >= 0) return Qtrue;
        return Qfalse;
    }

between?(min, max) → true or false click to toggle source

Returns `false` if obj `<=>` min is less than zero or if anObject `<=>` max is greater than zero, `true` otherwise.

    3.between?(1, 5)               #=> true
    6.between?(1, 5)               #=> false
    'cat'.between?('ant', 'dog')   #=> true
    'gnu'.between?('ant', 'dog')   #=> false

    static VALUE
    cmp_between(VALUE x, VALUE min, VALUE max)
    {
        if (cmpint(x, min) < 0) return Qfalse;
        if (cmpint(x, max) > 0) return Qfalse;
        return Qtrue;
    }

clamp(min, max) → obj click to toggle source

Returns min if obj `<=>` min is less than zero, max if obj `<=>` max is greater than zero and obj otherwise.

    12.clamp(0, 100)         #=> 12
    523.clamp(0, 100)        #=> 100
    -3.123.clamp(0, 100)     #=> 0

    'd'.clamp('a', 'f')      #=> 'd'
    'z'.clamp('a', 'f')      #=> 'f'

    static VALUE
    cmp_clamp(VALUE x, VALUE min, VALUE max)
    {
        int c;

        if (cmpint(min, max) > 0) {
            rb_raise(rb_eArgError, "min argument must be smaller than max argument");
        }

        c = cmpint(x, min);
        if (c == 0) return x;
        if (c < 0) return min;
        c = cmpint(x, max);
        if (c > 0) return max;
        return x;
    }